// BackupMBR.cpp : Defines the entry point for the console application.
//

#include <Windows.h>

#include <iostream>
#include <iomanip>
#include <vector>
#include <fstream>

#include "stdafx.h"

#include "types.h"
#include "Utils.h"
#include "file_io.h"


#define MBR_SIZE 0x200
using namespace std;



int main(int argc, char* argv[])
{

	//open physical drive
	HANDLE handle_r = create_io_file("\\\\.\\PhysicalDrive0",
								    GENERIC_READ,
									OPEN_EXISTING,
									FILE_ATTRIBUTE_NORMAL);

	if(handle_r == INVALID_HANDLE_VALUE)
	{
		cout<<"Can't open file";
		return 0;
	}


	u_char buffer[MBR_SIZE];

	// get mbr
	u_long result_ = read_io_file(handle_r, buffer, MBR_SIZE);
	if (result_ == -1)
	{
		close_io_file(handle_r);
		cout<<"Can't read source file";
		return 0;
	}

	// dump mbr to mbr_backup
	HANDLE handle_w = create_io_file("mbr_backup"
		, GENERIC_WRITE 
		, CREATE_ALWAYS 
		, FILE_ATTRIBUTE_NORMAL);

	if(handle_w == INVALID_HANDLE_VALUE)
	{
		cout<<"Can't open file";
		return 0;
	}

	result_ = write_io_file(handle_w, buffer, MBR_SIZE);
	if (result_ == -1)
	{
		close_io_file(handle_r);
		cout<<"Can't write dump file";
		return 0;
	}


	//get drive info

	drive_info drive_info_;
	if(get_drive_info(handle_r, drive_info_))
	{
		//store disk geometry
		store_drive_geometry(drive_info_);
	}

	// close handles
	close_io_file(handle_r);
	close_io_file(handle_w);

	return 0;
}
